

proc nextart { w inc } {
	global news

	if { $inc == 1 } {
		if { $news($w,idx) >= [.$news($w,ts).main size] } {
			return
		}
	} else {
		if { $news($w,idx) <= 0 } {
			return
		}
	}
	incr news($w,idx) $inc
	readart1 $w
}

proc readart1 { txt} {
	global news  newsread  newsunread

	set g   $news($txt,g)
	set ts  $news($txt,ts)
	set idx $news($txt,idx)

	set lst ".$ts.main"

	# Get the article number from the list entry
	set l1 [$lst get $idx]
	set a [lindex [split $l1] 0]
	if { $a == "" } { return } 
	wm title $txt "$l1"
	update

	#  Get a seperate connection for this window
	set news($txt,sock)  [connectit]
	if { $news($txt,sock) == "" } {
		unset news($txt,sock) 
		destroy $txt
		return
	}

	set news($txt,stop) 0
	$txt.main delete 0.0 end
	$txt.mail configure -state disabled
	$txt.reply configure -state disabled
	$txt.save configure -state disabled
	$txt.next configure -state disabled
	$txt.prev configure -state disabled
	socksend $news($txt,sock) "group $g"
	if { [rescode [readsock $news($txt,sock)] 211] } {
		closewin $txt,sock
		disconnect $news($txt,sock);
		return
	}
	socksend $news($txt,sock) "article $a"
	if { [rescode [readsock $news($txt,sock)] 220] } {
		closewin $txt,sock
		disconnect $news($txt,sock);
		return
	}
	set news($txt,message) "Getting article"
	set news($txt,l1) 0
	update
	fileevent $news($txt,sock) readable "readartln $txt"
	markit $g ".$ts.x" $idx $a X
}

proc readartln { w } {
	global news  newsread  newsunread

	if { [catch {eof $news($w,sock)} msg ] == -1 } {
		return
	}
	if { [eof $news($w,sock)] } {
		disconnect $news($w,sock);
		set news($w,message) "Unexpected end of file"
		$w.mail configure -state normal
		$w.reply configure -state normal
		$w.save configure -state normal
		$w.next configure -state normal
		$w.prev configure -state normal
		update
		return
	}
	set res [gets $news($w,sock)]
	if { $news(debug) == 1 } {
		debugmsg "readln: $news($w,sock) ($res)"
	}
	if { $res == "." || $news($w,stop) == 1 } {
		disconnect $news($w,sock);
		$w.mail configure -state normal
		$w.reply configure -state normal
		$w.save configure -state normal
		$w.next configure -state normal
		$w.prev configure -state normal
		set news($w,message) "Process Complete"
		update
	} else {
		incr news($w,l1)
		if { [expr $news($w,l1) % 10 ] == 0 } {
			update
		}
		ins_url $w.main "$res\n"
	}	
}

proc readart { g ts } {
	global news  newsread  newsunread

	set w1 ".$ts.main"
	set wx ".$ts.x"
	foreach idx [$w1 curselection] {

		#  Get a time stamp for the Window name
		set nts [clock format [clock seconds] -format %H%M%S]
		set w ".$nts"
		set txt "G$nts"
		window $w readart $txt text Done Mail Reply Save Next Prev
		$w.done configure -command "closewin $nts"
		$w.mail configure -command "mailart $w.main $g" -state disabled
		$w.reply configure -command "post $g $w.main" -state disabled
		$w.save configure -command "saveart $w" -state disabled
		$w.next configure -command "nextart $w 1" -state disabled
		$w.prev configure -command "nextart $w -1" -state disabled
	
		set news($w,stop) 0
		#  Configure the header area
		set news($w,g) $g
		set news($w,ts) $ts
		set news($w,idx) $idx
		readart1 $w
	}
}

proc readartold { g ts } {
	global news  newsread  newsunread

	set w1 ".$ts.main"
	set wx ".$ts.x"
foreach idx [$w1 curselection] {
	set l1 [$w1 get $idx]


	set a [lindex [split $l1] 0]
	#  Get a time stamp for the Window name
	set nts [clock format [clock seconds] -format %H%M%S]
	set w ".$nts"
	set txt "G$nts"
	window $w readart $txt text Done Mail Reply Save 
	wm title $w "$l1"
	update
	#  Get a seperate connection for this window
	set news($nts)  [connectit]
	if { $news($nts) == "" } {
		unset news($nts) 
		destroy $w
		return
	}

	set news($w,stop) 0
	$w.done configure -command "closewin $nts"
	$w.mail configure -command "mailart $w.main $g"
	$w.reply configure -command "post $g $w.main"
	$w.save configure -command "saveart $w"

	#  Configure the header area

	socksend $news($nts) "group $g"
	if { [rescode [readsock $news($nts)] 211] } {
		closewin $nts
		disconnect $news($nts);
		return
	}
	socksend $news($nts) "article $a"
	if { [rescode [readsock $news($nts)] 220] } {
		closewin $nts
		disconnect $news($nts);
		return
	}
	set count 0
	set news($w,message) "Getting article"
	set news($w,l1) 0
	update
	set res [readsock $news($nts)]
	while { $res != "." } {
		incr count
		if { $count > 5 } {
			incr news($w,l1) $count
			update
			set count 0
		}
		##  $w.main insert end "$res\n"
		ins_url $w.main "$res\n"
		set res [readsock $news($nts)]
	}	
	disconnect $news($nts);

	bind $w.main <Key> {}
	if { [$wx get $idx] != "X" } {
		incr news($g,count) -1
	}
	$wx insert $idx "X"
	incr idx
	$wx delete $idx
	set newsread($g,$a)  $a
	if { [info exists newsunread($g,$a)] } {
		catch {unset newsunread($g,$a)} msg
	}
	set news($w,message) ""
	if { $news(showall) == 0 } {
		refilter
	}
}
}
